package com.flyfish.framework.mongodb.config;

import com.flyfish.framework.mongodb.operations.MongoReactiveEntityOperations;
import com.flyfish.framework.mongodb.repository.factory.DefaultRepositoryFactoryBean;
import com.flyfish.framework.mongodb.repository.impl.DefaultRepositoryImpl;
import com.flyfish.framework.repository.ReactiveEntityOperations;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.mongodb.config.EnableMongoAuditing;
import org.springframework.data.mongodb.core.ReactiveMongoOperations;
import org.springframework.data.mongodb.repository.config.EnableMongoRepositories;

@EnableMongoRepositories(
        repositoryFactoryBeanClass = DefaultRepositoryFactoryBean.class,
        repositoryBaseClass = DefaultRepositoryImpl.class
)
@EnableMongoAuditing
@Configuration
public class MongoDataConfig {

    @Bean
    @ConditionalOnBean(ReactiveMongoOperations.class)
    public ReactiveEntityOperations mongoReactiveEntityOperations(ReactiveMongoOperations reactiveMongoOperations) {
        return new MongoReactiveEntityOperations(reactiveMongoOperations);
    }
}
